=== debian/changelog ===
aoflagger (3.0.0-2) unstable; urgency=medium

  * Add missing header file to fix FTBFS on non-x86 platforms

 -- Ole Streicher <olebole@debian.org>  Wed, 19 Aug 2020 15:30:15 +0200

aoflagger (3.0.0-1) unstable; urgency=medium

  * Adjust d/watch for new upstream repository
  * New upstream version 3.0.0. Rediff patches. Closes: #966866
  * Disable test cases that don't work before installation
  * Adjust installed files list and build dependencies

 -- Ole Streicher <olebole@debian.org>  Wed, 19 Aug 2020 14:36:10 +0200

aoflagger (2.15.0-3) unstable; urgency=medium

  * Improve finding of Boost Python (Closes: #962390, #956580)

 -- Ole Streicher <olebole@debian.org>  Fri, 12 Jun 2020 14:02:42 +0200

aoflagger (2.15.0-2) unstable; urgency=medium

  * Remove libboost-signals-dev (Closes: #960331)
  * Pin libboost build deps to 1.67 as workaround for #956580

 -- Ole Streicher <olebole@debian.org>  Wed, 03 Jun 2020 15:44:09 +0200

aoflagger (2.15.0-1) unstable; urgency=low

  * Add gitlab-ci.yml for salsa
  * New upstream version 2.15.0
  * Drop patches that were applied upstream
  * Push Standards-Version to 4.5.0. No changes required
  * New build dependency liblua5.3-dev
  * Remove static lib from aoflagger-dev

 -- Ole Streicher <olebole@debian.org>  Wed, 26 Feb 2020 08:55:10 +0100
