=== debian/control ===
Source: aoflagger
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: casacore-dev,
               cmake,
               debhelper-compat (= 12),
               doxygen,
               gfortran,
               graphviz,
               libblas-dev,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libcfitsio-dev,
               libfftw3-dev,
               libgtkmm-3.0-dev,
               liblapack-dev,
               liblua5.3-dev,
               libpng-dev,
               libpython3-dev,
               libxml2-dev,
               pybind11-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
Homepage: https://sourceforge.net/projects/aoflagger/
Rules-Requires-Root: no

Package: aoflagger
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: aoflagger-dev
Description: Find RFI in radio astronomical observations
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 Besides the flagger, the software consists of tools to efficiently visualize
 data in different ways, such as plotting time-frequency diagrams and power
 spectra. It provides the programs aoflagger, rfigui, aoqplot, aoquality and
 more.

Package: libaoflagger0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Find RFI in radio astronomical observations (shared lib)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the shared library.

Package: aoflagger-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libaoflagger0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: aoflagger
Description: Find RFI in radio astronomical observations (development files)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the header file to compile own programs against
 the library.
