## aoflagger 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,47 +14,64 @@
 pkg_check_modules(GTKMM gtkmm-3.0>=3.0.0)
 pkg_check_modules(SIGCXX sigc++-2.0)
 
-include_directories(${CMAKE_SOURCE_DIR}/aocommon/include)
+# Find and include git submodules
+find_package(Git QUIET)
+if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+# Update submodules as needed
+    option(GIT_SUBMODULE "Check submodules during build" ON)
+    if(GIT_SUBMODULE)
+        message(STATUS "Submodule update")
+        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive --checkout
+                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+                        RESULT_VARIABLE GIT_SUBMOD_RESULT)
+        if(NOT GIT_SUBMOD_RESULT EQUAL "0")
+            message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
+        endif()
+    endif()
+endif()
+
+# Include aocommon/pybind11 headers
+include_directories("${CMAKE_SOURCE_DIR}/aocommon/include")
+add_subdirectory("${CMAKE_SOURCE_DIR}/external/pybind11")
+include_directories(${pybind11_INCLUDE_DIR})
 
 set(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
 find_package(Casacore REQUIRED COMPONENTS casa ms tables measures)
+include_directories(${CASACORE_INCLUDE_DIRS})
 
 find_package(CFITSIO REQUIRED)
+include_directories(${CFITSIO_INCLUDE_DIR})
 
 find_path(FFTW3_INCLUDE_DIR NAMES fftw3.h)
 
 find_library(GSL_LIB NAMES gsl)
 find_library(GSL_CBLAS_LIB NAMES gslcblas)
 find_path(GSL_INCLUDE_DIR NAMES gsl/gsl_version.h)
+if(GSL_INCLUDE_DIR)
+  include_directories(${GSL_INCLUDE_DIR})
+endif(GSL_INCLUDE_DIR)
 
 find_package(Threads REQUIRED)
 find_package(LibXml2 REQUIRED)
+include_directories(${LIBXML2_INCLUDE_DIR})
+
 find_package(PNG REQUIRED)
-#Prevent accidentally finding old BoostConfig.cmake file from casapy
 find_package(PythonLibs 3 REQUIRED)
 find_package(PythonInterp REQUIRED)
 message(STATUS "Using python version ${PYTHON_VERSION_STRING}")
-find_package(pybind11 REQUIRED)
-
-set(Boost_NO_BOOST_CMAKE ON)
+include_directories(${PYTHON_INCLUDE_DIRS})
+
 # boost::alignment requires Boost 1.56
 find_package(Boost 1.56.0 REQUIRED COMPONENTS date_time filesystem system unit_test_framework)
+include_directories(${Boost_INCLUDE_DIR})
+
 find_library(FFTW3_LIB fftw3 REQUIRED)
+include_directories(${FFTW3_INCLUDE_DIR})
+
 enable_language(Fortran OPTIONAL)
 find_package(BLAS REQUIRED)
 find_package(LAPACK REQUIRED)
-find_package(Lua REQUIRED)
-
-include_directories(${PYBIND11_INCLUDE_DIR})
-include_directories(${CASACORE_INCLUDE_DIRS})
-include_directories(${Boost_INCLUDE_DIR})
-include_directories(${LIBXML2_INCLUDE_DIR})
-include_directories(${CFITSIO_INCLUDE_DIR})
-include_directories(${FFTW3_INCLUDE_DIR})
-if(GSL_INCLUDE_DIR)
-	include_directories(${GSL_INCLUDE_DIR})
-endif(GSL_INCLUDE_DIR)
-include_directories(${PYTHON_INCLUDE_DIRS})
+find_package(Lua 5.2 REQUIRED)
 include_directories(${LUA_INCLUDE_DIR})
 
 # The following stuff will set the "rpath" correctly, so that
@@ -77,8 +94,11 @@
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror=vla -DNDEBUG -funroll-loops -O3 -std=c++11")
 
-string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--no-undefined")
-
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+  message(STATUS "Debug build selected: setting linking flag --no-undefined")
+  string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--no-undefined")
+endif()
+  
 include(CheckCXXCompilerFlag)
 include(CheckSymbolExists) 
 include(CheckCXXSymbolExists)
@@ -142,6 +162,7 @@
   rfigui/imagepropertieswindow.cpp
   rfigui/heatmapwidget.cpp
   rfigui/msoptionwindow.cpp
+  rfigui/opendialog.cpp
   rfigui/plotframe.cpp
   rfigui/plotwindow.cpp
   rfigui/progresswindow.cpp
@@ -236,6 +257,7 @@
   imagesets/filterbankset.cpp
   imagesets/fitsimageset.cpp
   imagesets/imageset.cpp
+  imagesets/indexableset.cpp
   imagesets/msimageset.cpp
   imagesets/parmimageset.cpp
   imagesets/pngreader.cpp
@@ -336,6 +358,8 @@
 	test/experiments/highpassfilterexperiment.cpp
 	
 	test/lua/defaultstrategytest.cpp
+	test/lua/flagnanstest.cpp
+	test/lua/tmetadata.cpp
 	test/lua/optionsfunctiontest.cpp
 	test/lua/telescopefiletest.cpp
 	
@@ -356,6 +380,8 @@
 		
 	test/structures/image2dtest.cpp
 	test/structures/timefrequencydatatest.cpp
+	test/structures/tmask2d.cpp
+	test/structures/tversionstring.cpp
 	
 	test/util/numberparsertest.cpp
 	
@@ -363,27 +389,3 @@
 target_link_libraries(runtests aoflagger-lib ${ALL_LIBRARIES})
 
 add_test(runtests runtests)
-add_custom_target(check COMMAND runtests DEPENDS runtests)
-
-install (FILES interface/aoflagger.h DESTINATION include)
-install (DIRECTORY data/icons data/applications DESTINATION share )
-install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/data/strategies DESTINATION share/aoflagger FILES_MATCHING PATTERN *.lua)
-
-# Set-up cmake configuration files
-configure_file(
-    "${PROJECT_SOURCE_DIR}/cmake/config/aoflagger-config.cmake.in"
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config.cmake" @ONLY)
-configure_file(
-    "${PROJECT_SOURCE_DIR}/cmake/config/aoflagger-config-version.cmake.in"
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config-version.cmake" @ONLY)
-
-install(FILES
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config.cmake"
-    "${PROJECT_BINARY_DIR}/CMakeFiles/aoflagger-config-version.cmake"
-    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/aoflagger/cmake)
-
-add_subdirectory(python)
-
-add_custom_target(sphinxdoc
-  make html
-  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc
