=== debian/changelog ===
aoflagger (3.1.0-2build3) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 15 Jan 2022 08:33:12 +0000

aoflagger (3.1.0-2build2) jammy; urgency=medium

  * No-change rebuild against current libglibmm-2.4-1v5.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 02:20:07 +0000

aoflagger (3.1.0-2build1) jammy; urgency=medium

  * No-change rebuild against current libglibmm-2.4-1v5.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 02:03:53 +0000

aoflagger (3.1.0-2) unstable; urgency=medium

  * Make compile with gcc11 (Closes: #983967)

 -- Ole Streicher <olebole@debian.org>  Mon, 01 Nov 2021 10:09:56 +0100

aoflagger (3.1.0-1) unstable; urgency=medium

  * New upstream version 3.1.0
  * Rediff patches
  * Push Standards-Version to 4.6.0. No changes needed
  * Update build dependencies
  * Use system provided pybind11
  * Push dh-compat to 13. Create d/not-installed

 -- Ole Streicher <olebole@debian.org>  Mon, 30 Aug 2021 15:05:16 +0200
