=== debian/control ===
--- 
+++ 
@@ -1,21 +1,20 @@
 Source: aoflagger
 Section: science
 Priority: optional
-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: casacore-dev,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                doxygen,
                gfortran,
                graphviz,
                libblas-dev,
                libboost-date-time-dev,
-               libboost-dev,
                libboost-filesystem-dev,
                libboost-system-dev,
                libboost-test-dev,
-               libboost-thread-dev,
                libcfitsio-dev,
                libfftw3-dev,
                libgtkmm-3.0-dev,
@@ -25,8 +24,9 @@
                libpython3-dev,
                libxml2-dev,
                pybind11-dev,
+               python3-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
 Homepage: https://sourceforge.net/projects/aoflagger/
